/*
 * bsrc2.c : ubN\[gƃWR[_ɂt@C̈k
 *
 *  
 *  2003-07-17  ver 1.0
 *  2004-05-15  ver 2.0 (1) O@ (ratio-2) + }`L[NCbN\[g
 *                      (2) 0-1-2 coding + structured model + @
 *
 *          Copyright (C) 2003,2004 Makoto Hiroi
 */
#include "bsrc2.h"

/* O[oϐ */
int  eflag = FALSE;     /* encode */
int  dflag = FALSE;     /* decode */
int  sflag = FALSE;     /* 0 : O@ (ratio-2), 1 : Larsson, Sadakane @ */
int  bflag = FALSE;     /* N = 1 - 10 : buffer size is 512k * N */
int  vflag = FALSE;

char input_name[FILENAME_MAX];
char output_name[FILENAME_MAX];
char *file_header ="BRC2";

/* obt@` */
Uchar *sort_buffer;  /* ubN\[gpobt@ */
Uchar *work_buffer;  /* Ɨpobt@ */
int   max_data_size; /* MAX data size */

Uchar **sort_table;  /* O@ (ratio-2) */
int   *sort2_table;  /* Larsson, Sadakane @ */
int   *rank_table;
int   data_size;

/* obt@̎擾 */
void *get_buffer( int size )
{
  void *buffer = malloc( size );
  if( buffer == NULL ){
    fprintf( stderr, "Out of Memory\n" ); exit( 1 );
  }
  return buffer;
}

/***** RangeCoder *****/

/* 0-1-2 coding */
int c0000, c000, c00, c0;                  /* ŐL */
Frequency *freq_012_h[GR1][GR1][GR1][GR1]; /* order-4 */
Frequency *freq_012_l[GR1];                /* order-1 */
Frequency *freq_012_mix;                   /* p */

/* structured model */
int f00, f0;                           /* first code : ŐLL */
Frequency *freq_first_h[GR2][GR2];     /* first code : order-2 */
Frequency *freq_first;                 /* first code : order-0 */
Frequency *freq_first_mix;             /* p */
Frequency *freq_second[GR2];           /* second code */

/***** first code  scond code ̑Ή *****
  
  0 (1)   : 0 (2 - 2)
  1 (2)   : 1, 2
  2 (4)   : 3 - 6
  3 (8)   : 7 - 14
  4 (16)  : 15 - 30
  5 (32)  : 31 - 62
  6 (64)  : 63 - 126
  7 (128) : 127 - 254 (256 - 2)

*/

/* O[v̑傫 */
int group_size[GR2] = {
  1, 2, 4, 8, 16, 32, 64, 128,
};

/* O[v̉l */
int group_low[GR2] = {
  0, 1, 3, 7, 15, 31, 63, 127,
};

/* LƃO[v̑Ή\ */
int group_table[CODE_SIZE];

/* opx\̎擾 */
Frequency *get_frequency( int size, int max, int inc )
{
  Frequency *freq = get_buffer( sizeof( Frequency ) );
  freq->code_size = size;
  freq->max_sum   = max;
  freq->inc_num   = inc;
  freq->count     = get_buffer( sizeof( Ushort ) * size );
  freq->count_sum = get_buffer( sizeof( Ushort ) * (size + 1) );
  return freq;
}

/* O[oϐ̏ */
void init_range_coder_global( void )
{
  int i, j, k, l;
  /* group Ή\̏ */
  for( i = j = 0; i < GR2; i++ ){
    for( k = 0; k < group_size[i]; k++ ){
      group_table[j++] = i;
    }
  }
  /* 0-1-2 coding p */
  for( i = 0; i < GR1; i++ ){
    /* order-1 */
    freq_012_l[i] = get_frequency( GR1, MAX_SUM1, INC1 );
    for( j = 0; j < GR1; j++ ){
      for( k = 0; k < GR1; k++ ){
        for( l = 0; l < GR1; l++ ){
          /* order-4 */
          if( i && j && k && l ){
            freq_012_h[i][j][k][l] = get_frequency( GR1, MAX_SUM2, INC4 );
          } else {
            freq_012_h[i][j][k][l] = get_frequency( GR1, MAX_SUM1, INC4 );
          }
        }
      }
    }
  }
  /* p */
  freq_012_mix = get_frequency( GR1, MAX_SUM1, INC );

  /* first code : order-0 */
  freq_first = get_frequency( GR2, MAX_SUM2, INC0 );
  for( i = 0; i < GR2; i++ ){
    for( j = 0; j < GR2; j++ ){
      /* first code : order-2 */
      freq_first_h[i][j] = get_frequency( GR2, MAX_SUM2, INC2 );
    }
  }
  /* p */
  freq_first_mix = get_frequency( GR2, MAX_SUM2, INC );
  /* second code : 0  dummy */
  for( i = 1; i < GR2; i++ ){
    freq_second[i] = get_frequency( group_size[i], MAX_SUM3, INC );
  }
}

/* opx\̏ */
void init_frequency_table( Frequency *freq )
{
  int i, size = freq->code_size;
  for( i = 0; i < size; i++ ){
    freq->count[i] = 0;
    freq->count_sum[i] = 0;
  }
  freq->count_sum[size] = 0;
}

void init_frequency( void )
{
  int i, j, k, l;
  /* 0-1-2 coding */
  for( i = 0; i < GR1; i++ ){
    /* order-1 */
    init_frequency_table( freq_012_l[i] );
    for( j = 0; j < GR1; j++ ){
      for( k = 0; k < GR1; k++ ){
        for( l = 0; l < GR1; l++ ){
          /* order-4 */
          init_frequency_table( freq_012_h[i][j][k][l] );
        }
      }
    }
  }
  /* first code : order-0 */
  init_frequency_table( freq_first );
  for( i = 0; i < GR2; i++ ){
    for( j = 0; j < GR2; j++ ){
      /* first code : order-2 */
      init_frequency_table( freq_first_h[i][j] );
    }
  }
  /* second code : 0  dummy */
  for( i = 1; i < GR2; i++ ){
    init_frequency_table( freq_second[i] );
  }
}

/* opx\̍XV */
void update_frequency( Frequency *freq, int c )
{
  int i, size = freq->code_size, inc = freq->inc_num;
  Ushort *count = freq->count, *count_sum = freq->count_sum;
  count[c] += inc;
  count_sum[size] += inc;
  if( count_sum[size] >= freq->max_sum ){
    count_sum[size] = 0;
    for( i = 0; i < size; i++ ){
      count[i] >>= 1;
      count_sum[size] += count[i];
    }
  }
}

/* 0-1-2 coding : p */
Frequency *mix_012_frequency( void )
{
  int i;
  Frequency *freq1 = freq_012_h[c0000][c000][c00][c0];
  Frequency *freq2 = freq_012_l[c0];
  Ushort *count1 = freq1->count, *count2 = freq2->count;
  Ushort *count = freq_012_mix->count;
  Ushort *count_sum = freq_012_mix->count_sum;
  count_sum[0] = 0;
  for( i = 0; i < GR1; i++ ){
    count[i] = count1[i] + count2[i];
    count_sum[i + 1] = count_sum[i] + count[i];
  }
  return freq_012_mix;
}

/* 0-1-2 coding : order-4, order-1 ̏opx\XV */
void update_mix_012_frequency( int c )
{
  int s;
  update_frequency( freq_012_h[c0000][c000][c00][c0], c );
  update_frequency( freq_012_l[c0], c );
  c0000 = c000;
  c000 = c00;
  c00 = c0;
  c0 = c;
}

/* first code : p */
Frequency *mix_first_frequency( void )
{
  int i;
  Frequency *freq1 = freq_first_h[f00][f0];
  Ushort *count1 = freq1->count, *count2 = freq_first->count;
  Ushort *count = freq_first_mix->count;
  Ushort *count_sum = freq_first_mix->count_sum;
  count_sum[0] = 0;
  for( i = 0; i < GR2; i++ ){
    count[i] = count1[i] + count2[i];
    count_sum[i + 1] = count_sum[i] + count[i];
  }
  return freq_first_mix;
}

/* first code : order-2, order-0 ̏opx\XV */
void update_mix_first_frequency( int c )
{
  update_frequency( freq_first_h[f00][f0], c );
  update_frequency( freq_first, c );
  f00 = f0;
  f0 = c;
}

/* second code : opx\̑I */
Frequency *select_second_frequency( int c )
{
  Frequency *freq = freq_second[c];
  int i, size = freq->code_size;
  Ushort *count = freq->count, *count_sum = freq->count_sum;
  count_sum[0] = 0;
  for( i = 0; i < size; i++ ){
    count_sum[i + 1] = count[i] + count_sum[i];
  }
  return freq;
}

/* オ*/
void overflow( Uchar *out, int wp )
{
  int i;
  for( i = wp - 1; i >= 0; i-- ){
    int c = out[i] + 1;
    out[i] = c;
    if( c < 256 ) break;
  }
}

/*  */
int range_encode( Uchar *out, Uchar *in, int size )
{
  int i, rp, wp, c;
  Uint range = ULONG_MAX, low = 0;
  /*  */
  init_frequency();
  rp = wp = 0;
  do {
    Frequency *freq;
    int c1, c2;
    if( rp < size ){
      c = in[rp++];
    } else {
      c = END;
    }
    /* 0-1-2 coding : @ */
    c1 = (c < 2 ? c : 2);
    freq = mix_012_frequency();
    RC_ENCODE( freq, c1, range, low, wp, out );
    update_mix_012_frequency( c1 );
    /* structured model */
    if( c >= 2 ){
      /* LO[vɕϊ */
      c1 = group_table[c - 2];
      c2 = (c - 2) - group_low[c1];
      /* first code ̕ : @ */
      freq = mix_first_frequency();
      RC_ENCODE( freq, c1, range, low, wp, out );
      update_mix_first_frequency( c1 );
      if( c1 > 0 ){
        /* second code ̕ */
        freq = select_second_frequency( c1 );
        RC_ENCODE( freq, c2, range, low, wp, out );
        update_frequency( freq, c2 );
      }
    }
  } while( c != END );
  /* Ō̏o */
  for( i = 0; i < 4; i++ ){
    out[wp++] = low >> 24;
    low <<= 8;
  }
  return wp;
}

/*****  *****/

/* LT */
int search_code( Frequency *freq, Ushort value )
{
  int c, size = freq->code_size;
  for( c = 0; c < size; c++ ){
    if((GET_CNT_SUM( freq ,c ) <= value) && (value < GET_CNT_SUM( freq, c + 1 ))) break;
  }
  if( c == size ){
    fprintf( stderr, "RangeCoder : decode error %d\n", c ); exit( 1 );
  }
  return c;
}

/*  */
int range_decode( Uchar *out, Uchar *in )
{
  int i, wp = 0;
  Uint range = ULONG_MAX, code;
  /*  */
  init_frequency();
  code = *in++;
  code = (code << 8) + *in++;
  code = (code << 8) + *in++;
  code = (code << 8) + *in++;

  while( TRUE ){
    Frequency *freq;
    int c, c1, c2;
    /* 0-1-2 coding : @ */
    freq = mix_012_frequency();
    RC_DECODE( freq, c, range, code, in );
    update_mix_012_frequency( c );
    /* structured model */
    if( c >= 2 ){
      /* first code ̕ : @ */
      freq = mix_first_frequency();
      RC_DECODE( freq, c1, range, code, in );
      update_mix_first_frequency( c1 );
      if( c1 > 0 ){
        /* second code ̕ */
        freq = select_second_frequency( c1 );
        RC_DECODE( freq, c2, range, code, in );
        update_frequency( freq, c2 );
        /* L𕜍 */
        c = group_low[c1] + c2 + 2;
      }
    }
    if( c == END ) break;
    out[wp++] = c;
  }
  return wp;
}

/***** ubN\[g ******/

/* P}\[g */
void insert_sort( int low, int high, int depth, int size )
{
  int i, j, len = size - depth;
  for( i = low + 1; i <= high ; i++ ){
    Uchar *tmp = sort_table[i];
    for( j = i - 1;
         j >= low && memcmp( tmp + depth, sort_table[j] + depth, len ) < 0;
         j-- ){
      sort_table[j + 1] = sort_table[j];
    }
    sort_table[j + 1] = tmp;
  }
}

/* ̑I */
int select_pivot_mq( int low, int high, int depth )
{
  int a = *(sort_table[low] + depth);
  int b = *(sort_table[(low + high) / 2] + depth);
  int c = *(sort_table[high] + depth);
  int d;
  if( a > b ){
    d = a; a = b; b = d;
  }
  /* ł a < b */
  if( b > c ){
    b = c;
    /* ł b < c, Ō a Ɣr */
    if( a > b ) b = a;
  }
  return b;
}

/* ċAX^bNɓWJ */
int low_stack[STACK_SIZE + 1];
int high_stack[STACK_SIZE + 1];
int depth_stack[STACK_SIZE + 1];

/* Multikey Quicksort */
int mquicksort2( int low, int high, int depth, int size )
{
  int sp = 0;
  PUSH_STACK( low, high, depth );
  while( sp > 0 ){
    /* X^bNf[^o */
    POP_STACK( low, high, depth );
    while( 1 ){
      if( high - low <= ISORT_NUM ){
        insert_sort( low, high, depth, size );
        break;
      } else {
        int pivot, i, j, k, l, m1, m2;
        /* ̑I */
        pivot = select_pivot_mq( low, high, depth );
        /* ŏ 4  */
        /* low - m1-1 (pivot) | m1 - j | i - m2 | m2+1 - high (pivot) */
        i = m1 = low;
        j = m2 = high;
        for(;;){
          while( i <= j ){
            k = *(sort_table[i] + depth) - pivot;
            if( k > 0 ) break;
            if( k == 0 ){        /* Ɠl[ֈړ */
              SWAP2( i, m1 );
              m1++;
            }
            i++;
          }
          while( i <= j ){
            k = *(sort_table[j] + depth) - pivot;
            if( k < 0 ) break;
            if( k == 0 ){        /* Ɠl[ֈړ */
              SWAP2( j, m2 );
              m2--;
            }
            j--;
          }
          if( i > j ) break;
          SWAP2( i, j );
          i++;
          j--;
        }
        /* 3  : < (low - m1-1), = (m1 - m2-1), > (m2 - high) */
        /* [ = 𒆉Ɉړ */
        k = MIN( m1 - low, i - m1 );
        for( l = 0; l < k; l++ ) SWAP2( low + l, j - l );
        m1 = low + (i - m1);
        /* E[ = 𒆉Ɉړ */
        k = MIN( high - m2, m2 - j );
        for( l = 0; l < k; l++ ) SWAP2( i + l, high - l);
        m2 = high - (m2 - j) + 1;
        
        /* < \[g */
        if( low < m1 - 1 ) PUSH_STACK( low, m1 - 1, depth );
        /* > \[g */
        if( m2 < high ) PUSH_STACK( m2, high, depth );
        /* = \[g */
        if( m1 >= m2 - 1 || depth + 1 == size ) break;
        low = m1;
        high = m2 - 1;
        depth++;
        if( sp >= STACK_SIZE || depth >= MAX_DEPTH ) return FALSE;
      }
    }
  }
  return TRUE;
}


/***** Two Stage Sort (O@ ratio-2) *****/

/* 擪 2 ̕z\[gp */
int   count[UCHAR_SIZE * UCHAR_SIZE];
int   count_sum[UCHAR_SIZE * UCHAR_SIZE + 1];
int   start[UCHAR_SIZE], end[UCHAR_SIZE];     /* Rs[̗̈ */
int   start2[UCHAR_SIZE * UCHAR_SIZE + 1];    /* ratio-2 p */
Uchar **work_table;                           /* ratio-2 p */

/* 擪 2 ŕzグ\[g */
void distsort( int size )
{
  int i;
  for( i = 0; i < UCHAR_SIZE * UCHAR_SIZE; i++ ) count[i] = 0;
  for( i = 0; i < size; i++ ) count[ GETCODE( i ) ]++;
  count_sum[0] = 0;
  for( i = 1; i <= UCHAR_SIZE * UCHAR_SIZE; i++ ){
    count_sum[i] = count[i - 1] + count_sum[i - 1];
  }
  for( i = 1; i < UCHAR_SIZE * UCHAR_SIZE; i++ ) count[i] += count[i - 1];
  for( i = size - 1; i >= 0; i-- ){
    int c = GETCODE( i );
    sort_table[ --count[c] ] = sort_buffer + i;
  }
}

/* type A \[g */
int sort_type_a( int size )
{
  int i, j;
  for( i = UCHAR_SIZE - 1; i >= 0; i-- ){
    /* type A (Si > Si+1) 
       type D (Si >= Si+ 2) Type E (Si < Si+2 ) ɕă\[g */
    for( j = 0; j < i; j++ ){
      int k = (i << 8) + j;
      int m, n;
      int h = count_sum[k + 1];
      start2[k] = h - 1;        /* ratio-2 p */
      for( n = m = count_sum[k]; n < h; n++ ){
        Uchar *ptr = sort_table[n];
        if( *ptr >= *(ptr + 2) ){
          sort_table[n] = sort_table[m];
          sort_table[m++] = ptr;
        }
      }
      if( m - count_sum[k] > 1 ){
        if( !mquicksort2( count_sum[k], m - 1, 2, size ) ) return FALSE;
      }
    }
  }
  return TRUE;
}

/* type B, C Zbg */
void set_type_bc( int size )
{
  int i;
  for( i = UCHAR_SIZE - 1; i >= 0; i-- ){
    int j, wp;
    for( j = 0; j <= i; j++ ){
      int k = (j << 8) + i;
      start[j] = count_sum[k];
      end  [j] = count_sum[k + 1] - 1;
    }
    /* O */
    for( wp = 0, j = count_sum[i << 8]; j < start[i]; j++ ){
      /* ratio-1 */
      Uchar *ptr = sort_table[j];
      if( ptr == sort_buffer ) ptr += size;
      if( *(ptr - 1) <= *ptr ){
        sort_table[ start[ *(ptr - 1) ]++ ] = ptr - 1;
      }
      /* ratio-2 */
      ptr = sort_table[j];
      if( ptr < sort_buffer + 2 ) ptr += size;
      if( *(ptr - 2) < *ptr && *(ptr - 2) > *(ptr - 1) ){
        /* work_table ɑޔ */
        work_table[wp++] = ptr - 2;
      }
    }
    /* 납O */
    for( j = count_sum[(i + 1) << 8] - 1; j > end[i]; j-- ){
      Uchar *ptr = sort_table[j];
      if( ptr == sort_buffer ) ptr += size;
      if( *(ptr - 1) <= *ptr ){
        sort_table[ end[ *(ptr - 1) ]-- ] = ptr - 1;
      }
      /* 2 O`FbN */
      ptr = sort_table[j];
      if( ptr < sort_buffer + 2 ) ptr += size;
      if( *(ptr - 2) < *ptr && *(ptr - 2) > *(ptr - 1) ){
        sort_table[ start2[(*(ptr - 2) << 8) + *(ptr - 1)]-- ] = ptr - 2;
      }
    }
    /* work_table Rs[ */
    while( wp > 0 ){
      Uchar *ptr = work_table[--wp];
      sort_table[ start2[(*ptr << 8) + *(ptr + 1)]-- ] = ptr;
    }
  }
}

/* Type C \[g */
int sort_type_c( int size )
{
  int i, j;
  for( i = 0; i < UCHAR_SIZE; i++ ){
    /* type C (Si < Si+1) 
       type D (Si > Si+2)  type E (Si <= Si+2) ɕă\[g */
    for( j = i + 1; j < UCHAR_SIZE; j++ ){
      int k = (i << 8) + j;
      int h = count_sum[k + 1];
      int m, n;
      start2[k] = count_sum[k];       /* ratio-2 p */
      for( n = m = count_sum[k]; n < h; n++ ){
        Uchar *ptr = sort_table[n];
        if( *ptr > *(ptr + 2) ){
          sort_table[n] = sort_table[m];
          sort_table[m++] = ptr;
        }
      }
      if( h - m > 1 ){
        if( !mquicksort2( m, h - 1, 2, size ) ) return FALSE;
      }
    }
  }
  return TRUE;
}

/* type A, B Zbg */
void set_type_ab( int size )
{
  int i;
  for( i = 0; i < UCHAR_SIZE; i++ ){
    int j, wp;
    for( j = i; j < UCHAR_SIZE; j++ ){
      int k = (j << 8) + i;
      start[j] = count_sum[k];
      end  [j] = count_sum[k + 1] - 1;
    }
    /* O */
    for( j = count_sum[i << 8]; j < start[i]; j++ ){
      /* ratio-1 */
      Uchar *ptr = sort_table[j];
      if( ptr == sort_buffer ) ptr += size;
      if( *(ptr - 1) >= *ptr ){
        sort_table[ start[ *(ptr - 1) ]++ ] = ptr - 1;
      }
      /* ratio-2 */
      ptr = sort_table[j];
      if( ptr < sort_buffer + 2 ) ptr += size;
      if( *(ptr - 2) > *ptr  && *(ptr - 2) < *(ptr - 1) ){
        sort_table[ start2[(*(ptr - 2) << 8) + *(ptr - 1)]++ ] = ptr - 2;
      }
    }
    /* 납O */
    for( wp = 0, j = count_sum[(i + 1) << 8] - 1; j > end[i]; j-- ){
      /* ratio-1 */
      Uchar *ptr = sort_table[j];
      if( ptr == sort_buffer ) ptr += size;
      if( *(ptr - 1) >= *ptr ){
        sort_table[ end[ *(ptr - 1) ]-- ] = ptr - 1;
      }
      /* ratio-2 */
      ptr = sort_table[j];
      if( ptr < sort_buffer + 2 ) ptr += size;
      if( *(ptr - 2) > *ptr && *(ptr - 2) < *(ptr - 1) ){
        /* work_table ɑޔ */
        work_table[wp++] = ptr - 2;
      }
    }
    /* work_table Rs[ */
    while( wp > 0 ){
      Uchar *ptr = work_table[--wp];
      sort_table[ start2[(*ptr << 8) + *(ptr + 1)]++ ] = ptr;
    }
  }
}

/*
 * ubN\[g 
 *
 * Input buffer : sort_buffer, Output buffer : work_buffer
 */
int blocksort_encode( int size )
{
  int i, a, c, max, top;
  /* Rs[ */
  memcpy( sort_buffer + size, sort_buffer, size );
  /* 擪 2 ŕz\[g */
  distsort( size );
  /* type A, C ̌JEg */
  for( i = 0, a = 0, c = 0, max = 0; i < UCHAR_SIZE; i++ ){
    int n = count_sum[(i << 8) + i] - count_sum[i << 8];
    if( max < n ) max = n;
    a += n;
    n = count_sum[(i + 1) << 8] - count_sum[(i << 8) + i + 1];
    if( max < n ) max = n;
    c += n;
  }
  /* work_table ̈̃Zbg */
  work_table = get_buffer( sizeof( Uchar * ) * max );
  /* Ȃ type \[g */
  if( a > c ){
    if( !sort_type_c( size ) ) return SORT_ERR;
    set_type_ab( size );
  } else {
    if( !sort_type_a( size ) ) return SORT_ERR;
    set_type_bc( size );
  }
  /* o */
  for( i = 0; i < size; i++ ){
    Uchar *ptr = sort_table[i];
    if( ptr == sort_buffer ) top = i;
    work_buffer[i] = *(ptr + size - 1);
  }
  free( work_table );
  return top;
}

/* ubN\[g  */
void blocksort_decode( Uchar *out, Uchar *in, int top, int size )
{
  Uchar *ptr;
  int i, count[UCHAR_SIZE];
  /* \[g */
  for( i = 0; i < UCHAR_SIZE; i++ ) count[i] = 0;
  for( i = 0; i < size; i++ ) count[ in[i] ]++;
  for( i = 1; i < UCHAR_SIZE; i++ ) count[i] += count[i - 1];
  for( i = size - 1; i >= 0; i-- ){
    ptr = in + i;
    sort_table[ --count[ *ptr ] ]= ptr;
  }
  /* o */
  ptr = sort_table[top]; 
  for( i = 0; i < size; i++ ){
    *out++ = *ptr;
    ptr = sort_table[ptr - in];
  }
}

/***** Larsson, Sadakane @ ******/

/* Rank ̔r */
int rankcmp( int p1, int p2, int depth )
{
  int i;
  for( i = depth; i < data_size; i += depth ){
    int r = GET_RANK( p1 + i ) - GET_RANK( p2 + i );
    if( r ) return r;
  }
  return 0;
}

/* P}\[gFŌ܂Ń\[g */
void insert_sort_rank( int low, int high, int depth )
{
  int i, j;
  for( i = low + 1; i <= high ; i++ ){
    int tmp = sort2_table[i];
    for( j = i - 1; j >= low && rankcmp( tmp, sort2_table[j], depth ) < 0; j-- ){
      sort2_table[j + 1] = sort2_table[j];
    }
    sort2_table[j + 1] = tmp;
  }
  /* N̐ݒ */
  for( ; low <= high; low++ ){
    rank_table[ sort2_table[low] ] = low;
    sort2_table[low] = -1;
  }
}

int select_pivot( int low, int high, int depth )
{
  /* _ɑI */
  int r;
  switch( rand() % 3 ){
  case 0:
    r = GET_RANK( sort2_table[low] + depth ); break;
  case 1:
    r = GET_RANK( sort2_table[(low + high) / 2] + depth ); break;
  default:
    r = GET_RANK( sort2_table[high] + depth );
  }
  return r;
}

/* Multikey Quicksort */
void mquicksort( int low, int high, int depth )
{
  if( high - low <= ISORT_NUM ){
    /* P}\[gi\[gj */
    insert_sort_rank( low, high, depth );
  } else {
    int pivot, i, j, k, l, m1, m2;
    pivot = select_pivot( low, high, depth );   /* ̑I */
    /* ŏ 4  */
    /* low - m1-1 (pivot) | m1 - j | i - m2 | m2+1 - high (pivot)*/
    i = m1 = low;
    j = m2 = high;
    for(;;){
      while( i <= j ){
        k = GET_RANK( sort2_table[i] + depth ) - pivot;
        if( k > 0 ) break;
        if( k == 0 ){      /* Ɠl[ֈړ */
          SWAP( i, m1 );
          m1++;
        }
        i++;
      }
      while( i <= j ){
        k = GET_RANK( sort2_table[j] + depth ) - pivot;
        if( k < 0 ) break;
        if( k == 0 ){      /* Ɠl[ֈړ */
          SWAP( j, m2 );
          m2--;
        }
        j--;
      }
      if( i > j ) break;
      SWAP( i, j );
      i++;
      j--;
    }
    /* 3  : < (low - m1-1), = (m1 - m2-1), > (m2 - high) */
    /* [ = 𒆉Ɉړ */
    k = MIN( m1 - low, i - m1 );
    for( l = 0; l < k; l++ ) SWAP( low + l, j - l );
    m1 = low + (i - m1);
    /* E[ = 𒆉Ɉړ */
    k = MIN( high - m2, m2 - j );
    for( l = 0; l < k; l++ ) SWAP( i + l, high - l);
    m2 = high - (m2 - j) + 1;
    /* < \[g */
    if( low < m1 ) mquicksort( low, m1 - 1, depth );
    /* = ̃NXV */
    if( m2 > m1 ){
      if( m2 - m1 == 1 ){
        /* \[g */
        rank_table[ sort2_table[m1] ] = m1;
        sort2_table[m1] = -1;
      } else {
        int rank = m2 - 1;
        while( m1 < m2 ) rank_table[ sort2_table[m1++] ] = rank;
      }
    }
    /* > \[g */
    if( m2 <= high ) mquicksort( m2, high, depth );
  }
}

/* Ne[u̍쐬 */
void make_rank_table( int size )
{
  int i;
  /* 擪 2 ŕzグ\[g */
  sort_buffer[size] = sort_buffer[0];
  for( i = 0; i < UCHAR_SIZE * UCHAR_SIZE; i++ ) count[i] = 0;
  for( i = 0; i < size; i++ ) count[ GETCODE( i ) ]++;
  count_sum[0] = 0;
  for( i = 1; i <= UCHAR_SIZE * UCHAR_SIZE; i++ ){
    count_sum[i] = count[i - 1] + count_sum[i - 1];
  }
  for( i = 1; i < UCHAR_SIZE * UCHAR_SIZE; i++ ) count[i] += count[i - 1];
  for( i = size - 1; i >= 0; i-- ){
    int c = GETCODE( i );
    sort2_table[ --count[c] ] = i;
    rank_table[i] = count_sum[c + 1] - 1;
  }
}

/*
 * ubN\[g 
 *
 * Input buffer : sort_buffer, Output buffer : work_buffer
 */
int blocksort2_encode( int size )
{
  int i, top, depth;
  /* O[oϐZbg */
  data_size = size;
  /* N̏ */
  make_rank_table( size );
  /* NgĒiKIɃ\[g */
  for( depth = 2; depth < size; depth *= 2 ){
    int low = 0, flag = TRUE;
    while( low < size ){
      int tmp = low;
      /* \[gς݃O[ṽXLbv */
      while( tmp < size && sort2_table[tmp] < 0 ) tmp -= sort2_table[tmp];
      if( low < tmp ){
        sort2_table[low] = -(tmp - low);
        low = tmp;
      }
      /* O[ṽ\[g */
      if( low < size ){
        int high = rank_table[ sort2_table[low] ];
        if( low > high ){
          fprintf( stderr, "BlockSort error %d - %d\n", low, high );
          exit( 1 );
        }
        mquicksort( low, high, depth );
        low = high + 1;
        flag = FALSE;
      }
    }
    if( flag ) break;
  }
  /* sort2_table 𕜌 */
  for( i = 0; i < size; i++ )  sort2_table[ rank_table[i] ] = i;
  /* o */
  for( i = 0; i < size; i++ ){
    int n = sort2_table[i];
    if( !n ){
      top = i;
      work_buffer[i] = sort_buffer[size - 1];
    } else {
      work_buffer[i] = sort_buffer[n - 1];
    }
  }
  return top;
}

/***** Run Length Encoding *****/

/*  : 0, 1 ͕Ȃ */
int rle_encode( Uchar *out, Uchar *in, int size, int n )
{
  Uchar *limit = in + size;
  int wp = 0;
  do {
    int c = *in++;
    if( wp >= size ) return size + 1;  /* error */
    if( c < 2 ){
      out[wp++] = c;
    } else {
      int k = 1;
      for( ; in < limit && k < n + MAX_LEN; in++ ){
        if( *in != c ) break;
        k++;
      }
      if( k >= n ){
        /* OX */
        int m;
        for( m = 0; m < n; m++ ) out[wp++] = c;
        k -= n;
        if( k <= 127 ){
          out[wp++] = k;
        } else {
          k -= 128;
          out[wp++] = (k >> 8) + 0x80;
          out[wp++] = k & 0xff;
        }
      } else {
        while( k-- > 0 ) out[wp++] = c;
      }
    }
  } while( in < limit );
  return wp;
}

/*  */
int rle_decode( Uchar *out, Uchar *in, int size, int n )
{
  Uchar *limit = in + size, *wp = out;
  do {
    int c = *in++;
    if( c < 2 ){
      *wp++ = c;
    } else {
      int k = 1;
      for( ; in < limit && k < n; in++ ){
        if( *in != c ) break;
        k++;
      }
      if( k == n ){
        /* c WJ */
        int m = *in++;
        if( m & 0x80 ){
          m &= 0x7f;
          k += (m << 8) + 128 + *in++;
        } else {
          k += m;
        }
      }
      while( k-- > 0 ) *wp++ = c;
    }
  } while( in < limit );
  return wp - out;
}

/***** Move To Front @ *****/

/*  */
void mtf_encode( Uchar *out, Uchar *in, int size )
{
  int i, prev = 1;
  Uchar mtf_table[256];
  for( i = 0; i < 256; i++ ) mtf_table[i] = i;
  for( i = 0; i < size; i++ ){
    int c = *in++;
    int j = 0;
    while( mtf_table[j] != c ) j++;
    if( j == 1 ){
      if( prev ){
        mtf_table[1] = mtf_table[0];
        mtf_table[0] = c;
      }
    } else if( j > 1 ){
      memmove( mtf_table + 2, mtf_table + 1, j - 1 );
      mtf_table[1] = c;
    }
    *out++ = j;
    prev = j;
  }
}

/*  */
void mtf_decode( Uchar *out, Uchar *in, int size )
{
  int i, prev = 1;
  Uchar mtf_table[256];
  for( i = 0; i < 256; i++ ) mtf_table[i] = i;
  for( i = 0; i < size; i++ ){
    int j = *in++;
    int c = mtf_table[j];
    if( j == 1 ){
      if( prev ){
        mtf_table[1] = mtf_table[0];
        mtf_table[0] = c;
      }
    } else if( j > 1 ){
      memmove( mtf_table + 2, mtf_table + 1, j - 1 );
      mtf_table[1] = c;
    }
    *out++ = c;
    prev = j;
  }
}

/***** O[oϐ̏ *****/
void init_global( void )
{
  max_data_size = DATA_SIZE * bflag;
  work_buffer = get_buffer( max_data_size );
  if( eflag ){
    /*  */
    if( sflag ){
      /* Larsson, Sadakane method */
      sort_buffer = get_buffer( max_data_size + OVER_RUN );
      sort2_table = get_buffer( max_data_size * sizeof( int ) );
      rank_table  = get_buffer( max_data_size * sizeof( int ) );
    } else {
      /* Two Stage Sort */
      sort_buffer = get_buffer( max_data_size * 2 );
      sort_table  = get_buffer( max_data_size * sizeof( Uchar * ) );
    }
  } else {
    /*  */
    sort_buffer = get_buffer( max_data_size );
    sort_table  = get_buffer( max_data_size * sizeof( Uchar * ) );
  }
  /* RangeCoder p */
  init_range_coder_global();
}

/* obt@̐؂ւ */
void change_sort_buffer( void )
{
  /* Two Stage Sort ̃obt@ */
  free( sort_table );
  /* Larsson, Sadakane @̃obt@擾 */
  sort2_table = get_buffer( max_data_size * sizeof( int ) );
  rank_table  = get_buffer( max_data_size * sizeof( int ) );
}


/*****  *****/

/* f[^o */
void output_data( Uchar *buff, int top, int size, int rle_flag, FILE *out )
{
  /* ʒuƃTCY 3 byte  OK */
  fputc( rle_flag, out );
  fputc( (top >> 16) & 0xff, out );
  fputc( (top >> 8) & 0xff, out );
  fputc( top & 0xff, out );
  fputc( (size >> 16) & 0xff, out );
  fputc( (size >> 8) & 0xff, out );
  fputc( size & 0xff, out );
  fwrite( buff, 1, size, out );
}

/*  */
void encode( FILE *in, FILE *out )
{
  int top, size, s1, rle_size;
  /* O[oϐ̏ */
  init_global();
  /* wb_[Cg */
  fwrite( file_header, 1, HEADER_SIZE, out );
  /* obt@TCYCg */
  fputc( bflag, out );
  while( (size = fread( sort_buffer, 1, max_data_size, in )) > 0 ){
    if( vflag ) printf("Input data <= %d bytes\n", size );
    /***** BlockSorting : sort_buffer -> work_buffer *****/
    if( sflag ){
      /* Larsson, Sadakane @ */
      if( vflag ) START_TIME( s1, "Sorting (Larsson, Sadakane method) ..." )
      top = blocksort2_encode( size );
    } else {
      /* Two Stage Sort */
      if( vflag ) START_TIME( s1, "Sorting (Two Stage Sort [O@:ratio-2]) ...")
      top = blocksort_encode( size );
      if( top == SORT_ERR ){
        if( vflag ) printf( "too repetitive\nuse Larsson, Sadakane method ..." );
        sflag = TRUE;
        change_sort_buffer();
        top = blocksort2_encode( size );
      }
    }
    if( vflag ) PRINT_TIME( s1 );

    /***** Move to Front *****/
    if( vflag ) START_TIME( s1, "Move To Front encoding ..." )
    mtf_encode( work_buffer, work_buffer, size );  /* work_buffer -> work_buffer */
    if( vflag ) PRINT_TIME( s1 );

    /***** RunLength *****/
    if( vflag ) START_TIME( s1, "Run Length encoding ..." )
    rle_size = rle_encode( sort_buffer, work_buffer, size, MIN_LEN );
    if( rle_size >= size ){
      /* RLE ͓Kp */
      if( vflag ) printf( " size over, skipped Run Length encoding\n" );
      rle_size = FALSE;
      memcpy( sort_buffer, work_buffer, size );
    } else {
      if( vflag ) PRINT_TIME( s1 );
      size = rle_size;
      rle_size = TRUE;
    }

    /***** RangeCoder *****/
    if( vflag ) START_TIME( s1, "RangeCoder encoding ..." )
    size = range_encode( work_buffer, sort_buffer, size );
    if( vflag ) PRINT_TIME( s1 );

    /* t@C֏o */
    output_data( work_buffer, top, size, rle_size, out );
    if( vflag ) printf("Output data => %d bytes\n\n", size );
  }
}

/* t@C̈k */
void encode_file( void )
{
  FILE	*in, *out;
  /* t@CI[v */
  in = fopen( input_name, "rb" );
  if( in == NULL ){
    fprintf( stderr, "%s ܂\n", input_name );
    exit( 1 );
  }
  out = fopen( output_name, "wb" );
  if( out == NULL ){
    fprintf( stderr, "%s I[vł܂\n", output_name );
    exit( 1 );
  }
  /*  */
  encode( in, out );
  fclose( in );
  fclose( out );
}


/*****  *****/

/*  */
void decode( FILE *in, FILE *out )
{
  int top, size, s1, rle_flag;
  /* O[oϐ̏ */
  init_global();
  do {
    /* ʒuƃTCY擾 */
    rle_flag = fgetc( in );
    if( rle_flag == EOF ) break; /* I */
    top = fgetc( in );
    top = (top << 8) + fgetc( in );
    top = (top << 8) + fgetc( in );
    size = fgetc( in );
    size = (size << 8) + fgetc( in );
    size = (size << 8) + fgetc( in );
    /***** f[^[h *****/
    if( fread( sort_buffer, 1, size, in ) != (size_t)size ){
      fprintf( stderr, "t@CĂ܂ %s\n", input_name );
      exit( 1 );
    }
    if( vflag ) printf( "Input data <= %d bytes\n", size );

    /***** RangeDecoder ******/
    if( vflag ) START_TIME( s1, "RangeCoder decoding ..." )
    size = range_decode( work_buffer, sort_buffer );
    if( vflag ) PRINT_TIME( s1 );

    /***** RunLength *****/
    if( rle_flag ){
      if( vflag ) START_TIME( s1, "Run Length decoding ..." )
      size = rle_decode( sort_buffer, work_buffer, size, MIN_LEN );
      if( vflag ) PRINT_TIME( s1 );
    } else {
      if( vflag ) printf( "Skipped Run Length decoding\n" );
      memcpy( sort_buffer, work_buffer, size );
    }

    /***** Move to Front *****/
    if( vflag ) START_TIME( s1, "Move To Front decoding ..." )
    mtf_decode( work_buffer, sort_buffer, size );
    if( vflag ) PRINT_TIME( s1 );

    /***** BlockSorting *****/
    if( vflag ) START_TIME( s1, "BlockSort decoding ..." )
    blocksort_decode( sort_buffer, work_buffer, top, size );
    if( vflag ) PRINT_TIME( s1 );
    
    /* t@C֏o */
    fwrite( sort_buffer, 1, size, out );
    if( vflag ) printf("Output data => %d bytes\n\n", size );
  } while( size == max_data_size );
}

/* t@C̉ */
void decode_file( void )
{
  FILE *in, *out;
  char buffer[HEADER_SIZE];
  int  size;

  /* ̓t@CI[v */
  in = fopen( input_name, "rb" );
  if( in == NULL ){
    fprintf( stderr, "%s ܂\n", input_name );
    exit( 1 );
  }

  /* wb_[`FbN */
  size = fread( buffer, 1, HEADER_SIZE, in );
  if( size != HEADER_SIZE || memcmp( file_header, buffer, HEADER_SIZE ) ){
    fprintf( stderr, "bsrc2 ł͏łȂt@Cł %s\n", input_name );
    exit( 1 );
  }
  /* obt@TCY[h */
  bflag = fgetc( in );
  /* o̓t@CI[v */
  out = fopen( output_name, "wb" );
  if( out == NULL ){
    fprintf( stderr, "%s I[vł܂\n", output_name );
    exit( 1 );
  }
  /*  */
  decode( in, out );
  fclose( in );
  fclose( out );
}


/***** ͂ƃC *****/

/* gp@ */
void usage( void )
{
  printf("BlockSroting and RangeCoder Compressor Sample Program ver 2.0\n");
  printf("\tCopyright (C) 2003,2004 Makoto Hiroi\n\n");
  printf("usage : bsrc2 [options] input_file output_file\n");
  printf("  -d  : \n"
         "  -e  : k\n"
         "  -bn : obt@TCY (n * 512kbyte : default = 2)\n"
         "  -s  : Larsson, Sadakane @ Ń\[g\n"
         "  -v  : so߂\\n");
  exit( 1 );
}

/*  */
void getargs( int argc, char *argv[] )
{
  int i;
  if( argc == 1 ) usage();
  for( i = 1; i < argc && argv[i][0] == '-'; i++ ){
    int opt = toupper( argv[i][1] );
    switch( opt ){
    case 'D': dflag = TRUE; break;
    case 'E': eflag = TRUE; break;
    case 'B':
      bflag = atoi( &(argv[i][2]) );
      if( bflag < 1 || bflag > 10 ){
        fprintf( stderr, "-b IvVɂ͐l (1 - 10) w肵Ă\n" );
        exit( 1 );
      }
      break;
    case 'S': sflag = TRUE; break;
    case 'V': vflag = TRUE; break;
    case '?': usage(); break;
    default :
      fprintf( stderr, "sȃIvVł\n" );
      usage();
    }
  }
  if( dflag && eflag ){
    fprintf( stderr, "-d  -e ͓Ɏwł܂\n" );
    exit( 1 );
  }
  if( !dflag && !eflag ){
    fprintf( stderr, "-d  -e ̂ǂ炩w肵Ă\n" );
    exit( 1 );
  }
  if( !bflag ) bflag = 2;
  if( i < argc ){
    strcpy( input_name, argv[i++] );
  } else {
    fprintf( stderr, "̓t@C܂\n" );
    exit( 1 );
  }
  if( i < argc ){
    strcpy( output_name, argv[i] );
  } else {
    fprintf( stderr, "o̓t@C܂\n");
    exit( 1 );
  }
}

int main( int argc, char *argv[] )
{
  int start = clock();
  getargs( argc, argv );
  if( dflag ) decode_file();
  else        encode_file();
  if( vflag ){
    printf("Total Time %.3f sec\n", (float)(clock() - start) / CLOCKS_PER_SEC );
  }
  return 0;
}

