/*
 * bsrc2.h : ubN\[gƃWR[_ɂt@C̈k
 *
 *          Copyright (C) 2003, 2004 Makoto Hiroi
 */
#ifndef _BSRC_H_
#define _BSRC_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <limits.h>
#include <time.h>

#define TRUE  1
#define FALSE 0

/* RnageCoder p̒萔 */
#define MIN_RANGE   0x01000000
#define MASK        0xff000000
#define MAX_SUM1    0x140
#define MAX_SUM2    0x200
#define MAX_SUM3    0x800
#define GR1         3
#define GR2         8
#define INC         4
#define INC4        2
#define INC1        14
#define INC2        4
#define INC0        12
#define CODE_SIZE   257
#define END         256

/* BlockSort p̒萔 */
#define UCHAR_SIZE  256
#define MIN_LEN     7
#define MAX_LEN     (0x7fff + 128)
#define DATA_SIZE   0x80000
#define OVER_RUN    0x100
#define ISORT_NUM   10
#define HEADER_SIZE 4
#define SORT_ERR    (-1)

typedef unsigned char  Uchar;
typedef unsigned short Ushort;
typedef unsigned int   Uint;

/* opx\̒` */
typedef struct {
  Ushort code_size, max_sum, inc_num;
  Ushort *count, *count_sum;
} Frequency;

/* WR[_p}N֐ */
#define GET_SUM( f )        ((f)->count_sum[(f)->code_size] + (f)->code_size)
#define GET_CNT( f, c )     ((f)->count[(c)] + 1)
#define GET_CNT_SUM( f, c ) ((f)->count_sum[(c)] + (c))

/* p}N */
#define RC_ENCODE( freq, sym, range, low, wp, out ){ \
  Uint tmp = range / GET_SUM( freq ); \
  Uint add = tmp * GET_CNT_SUM( freq, sym ); \
  if( ~low < add ) overflow( out, wp ); \
  low += add; \
  range = tmp * GET_CNT( freq, sym ); \
  while( range < MIN_RANGE ){ \
    out[wp++] = low >> 24; \
    range <<= 8; \
    low <<= 8; \
  } \
}

/* p}N */
#define RC_DECODE( freq, sym, range, code, in ){ \
  Uint tmp = range / GET_SUM( freq ); \
  sym = search_code( freq, code / tmp ); \
  code -= tmp * GET_CNT_SUM( freq, sym ); \
  range = tmp * GET_CNT( freq, sym ); \
  while( range < MIN_RANGE ){ \
    range <<= 8; \
    code = (code << 8) + *in++; \
  } \
}

/****** Multikey Quicksort ******/

#define STACK_SIZE 1024
#define MAX_DEPTH  1024

#define SWAP2( a, b ) {\
  Uchar *tmp = sort_table[(a)]; \
  sort_table[(a)] = sort_table[(b)]; \
  sort_table[(b)] = tmp; \
}

#define PUSH_STACK( low, high, depth ) {\
  low_stack[sp] = (low); high_stack[sp] = (high); depth_stack[sp++] = depth; \
}

#define POP_STACK( low, high, depth ) {\
  low = low_stack[--sp]; high = high_stack[sp]; depth = depth_stack[sp]; \
}

/***** Larsson - Sadakane @ ******/

/* 2 ̕zグp}N */
#define GETCODE( n ) ((sort_buffer[(n)] << 8) + sort_buffer[(n) + 1])

/* N̎擾 */
#define GET_RANK( n ) ((n) < data_size ? rank_table[(n)] : rank_table[(n) - data_size])
#define MIN( a, b )   ((a) < (b) ? (a) : (b))
#define SWAP( a, b ) {\
  int tmp = sort2_table[(a)]; \
  sort2_table[(a)] = sort2_table[(b)]; \
  sort2_table[(b)] = tmp; \
}

/* vJn */
#define START_TIME( n, m ) { (n) = clock(); printf( (m) ); }
/* Ԃ̕\ */
#define PRINT_TIME( n ) printf(" done %.3f sec\n",(float)(clock() - (n))/CLOCKS_PER_SEC)

#endif
